﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Classy_1;
using Clio.Utilities;
using Clio.XmlEngine;
using ff14bot.Behavior;
using ff14bot.Helpers;
using ff14bot.Managers;
using ff14bot.Navigation;
using ff14bot.NeoProfiles;
using ff14bot.RemoteWindows;
using TreeSharp;
using System.Threading;
using Action = TreeSharp.Action;

namespace ff14bot.NeoProfile
{

    [XmlElement("ChangeJob")]
    class ChangeJobTag : ProfileBehavior
    {
        private bool _done;
        private Form1 _form;
        [XmlAttribute("Type")]
        public string selectedClass { get; set; }

        public override bool IsDone { get { return _done; } }

    
        protected new Composite Behavior()
        {

            var binding = Form1.bindings;
           // string currentJob = Core.Me.CurrentJob.ToString();
            string selectedJob = Enum.Parse(typeof(Enums.ClassJobType), selectedClass, true).ToString();
            
            string selecting;
            return new PrioritySelector(
                //added decorator as suggested by kagamihiiragi17 .. Also start/stop to treeroot.. Seems to be working for me at the moment.
                    new Decorator(ret => Core.Player.CurrentJob.ToString() == selectedJob && !IsDone,
                          new Action(r =>
                              {
                               //   Logging.Write(selectedClass + " vs " + Core.Player.CurrentJob.ToString());
                               //    ff14bot.TreeRoot.Stop();
                                  _done = true;
                                  Thread.Sleep(4000);
                              //    ff14bot.TreeRoot.Start();
                                
                              }
                             )
                           ),
                new Decorator(ret => !Core.Me.InCombat && Core.Me.IsAlive && !IsDone && Core.Player.CurrentJob.ToString() != selectedJob,
                    new Action(r =>
                    {
                       // Logging.Write(selectedClass + " vs " + Core.Player.CurrentJob.ToString());
                        binding.TryGetValue(selectedClass, out selecting);
                        string message = "/gs change " + selecting;
                        ChatManager.SendChat(message);
                       
                     


                    }


                    )));

        }

        public bool IsSameJob(string type1, string type2)
        {
            return (string.Compare(type1, type2, true) == 0);
        }


        protected override void OnResetCachedDone()
        {
            _done = false;
        }


        private Composite _cache;

        protected override void OnStart()
        {
            _cache = Behavior();
            TreeHooks.Instance.InsertHook("TreeStart", 0, _cache);
        }

        protected override void OnDone()
        {     //not sure if these are fixing anything, but havent had any issues since adding them
			  //however I changed alot more stuff around since adding these as well.. keeping them "just in case"
            ff14bot.Managers.RoutineManager.ReloadRoutineAssemblies();
            ff14bot.Managers.RoutineManager.SetCurrentCombatRoutine();
           // Logging.Write(selectedClass + " vs " + Core.Player.CurrentJob.ToString());
           // Logging.Write("[Classy] - OnDone() Called");
           // Poi.Current = new Poi(location, currentType);
         
        }

    }



}
